#!/usr/bin/env python3.9


import maude
from objmodel import *
from bodyprocessor import BodyProcessor
from topmethods import get_mod_by_name


class CondProcessor:
    def __init__(self, top: MaudeTop, fm: FModule) -> None:
        maude.init(advise=False)
        maude.input(self.textWithDeps(top, fm, []))
        self.__mod = fm
        self.__maudeModule = maude.getModule(fm.name)

    def textWithDeps(self, top: MaudeTop, m: Module, already: List[str]) \
            -> str:
        res = ""
        for i in BodyProcessor(m.body).all_imports:
            if isinstance(i, Protecting) \
                    or isinstance(i, Extending) \
                    or isinstance(i, Including):
                if i.mod_expr.name not in already:
                    already.append(i.mod_expr.name)
                    m2 = get_mod_by_name(top, i.mod_expr.name)
                    if m2 is not None:
                        res += "\n\n" + self.textWithDeps(top, m2, already)
        return res + "\n\n" + str(m)

    @property
    def mod(self) -> Module:
        return self.__mod

    def reduce(self, e: str) -> str:
        t = self.__maudeModule.parseTerm(e)
        t.reduce()
        return str(t)
