#!/usr/bin/env python3.9


import re
# We need to use `re.escape` because backslashes are not allowed in f-strings.


def balParens(n: int):
    return r'\(' + r'[^()]*(\(' * n + r'[^()]*' + r'\)[^()]*)*' * n + r'\)'


def token(*ss: str) -> str:
    br_chars = re.escape('[]{}(),')  # Maude's breaking chars
    if ss == ():
        return rf'((?<!`)[{br_chars}])'\
               + '|'\
               + '('\
               + rf'(^|(?<=\s|(?<!`)[{br_chars}]))'\
               + rf'((([^\s{br_chars}]|(?<=`)[{br_chars}]))+)'\
               + rf'(?=\s|[{br_chars}]|$)'\
               + ')'
    else:
        brk = []
        oth = []
        for s in ss:
            if len(s) == 1 and s[0] in br_chars:
                brk.append(rf'\{s}')
            else:
                oth.append(rf'({s})')
        if len(brk) > 0 and len(oth) > 0:
            brkRes = rf'((?<!`)({"|".join(brk)}))'
            othRes = rf'(^|(?<=\s|(?<!`)[{br_chars}]))'\
                + rf'({"|".join(oth)})(?=\s|[{br_chars}]|$)'
            return rf'(({brkRes})|({othRes}))'
        elif len(brk) > 0:
            brkRes = rf'((?<!`)({"|".join(brk)}))'
            return rf'({brkRes})'
        elif len(oth) > 0:
            othRes = rf'(^|(?<=\s|(?<!`)[{br_chars}]))'\
                + rf'({"|".join(oth)})(?=\s|[{br_chars}]|$)'
            return rf'({othRes})'
        else:
            assert False


def anyTokenBut(*ss: str) -> str:
    return rf'(?!{token(*ss)})({token()})'


def terminal_defs() -> str:
    ids = fr'''
ID: /{anyTokenBut(re.escape('.'))}/
SORT_ID: /{anyTokenBut('<', re.escape('.'))}/
'''
    tokens = rf'''
TOKEN_PAREN_RE: /{balParens(5)}/
TOKEN_RHS_RE: /{anyTokenBut(re.escape('.'), '(')}/
TOKEN_EQ_LHS_RE: /{anyTokenBut('=')}/
TOKEN_MB_LHS_RE: /{anyTokenBut(':')}/
TOKEN_RL_LHS_RE: /{anyTokenBut('=>', re.escape('=['))}/
TOKEN_ERL_MID_RE: /{anyTokenBut(re.escape(']=>'))}/
TOKEN_CEQ_CRL_RHS_RE: /{anyTokenBut('if', '(')}/
TOKEN_COND_LHS_RE: /{anyTokenBut('=>', ':=', ':', '=', re.escape('.'))}/
'''
    atomic_formulas = rf'''
ATOMIC_FORMULA: /{anyTokenBut('True', 'False')}/
'''
    return ids + tokens + atomic_formulas
